/***************************************************************************
                          entry.cpp  -  description
                             -------------------
    begin                : ??? Dec 5 2007
    copyright            : (C) 2007 by Krasu
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstylesheet.h>

#include <kio/global.h>
#include <kglobal.h>

#include "entry.h"
#include "kwconfig.h"

unsigned long Entry::globalid = 0;

QString Entry::tableEntry() const
{
    QString result;

    static const QString &minus = KGlobal::staticQString("-");

    KWConfig::instance()->setGroup("General");

    result = KWConfig::instance()->readEntry("message_format", "<td><b>%p</b></td> <td><b>%s</b></td> <td><b>%us</b></td> <td>%l:%lp</td> <td>%i</td> <td>%r:%rp</td>");

    result.replace("%t", KIO::convertSeconds(time.secsTo(QDateTime::currentDateTime())));
    result.replace("%s", service);
    result.replace("%lp", QString::number(addressLocalPort));
    result.replace("%l", addressLocal);
    result.replace("%i", QStyleSheet::escape(incomingString));
    result.replace("%rp", QString::number(addressRemotePort));
    result.replace("%p", app.isEmpty() ? minus : app);
    result.replace("%r", addressRemote);
    result.replace("%us", userString);
    result.replace("%u", QString::number(user));

    return result;
}
