/***************************************************************************
                          entry.h  -  description
                             -------------------
    begin                : ??? Dec 5 2007
    copyright            : (C) 2007 by Krasu
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ENTRY_H
#define ENTRY_H

#include <qstring.h>
#include <qdatetime.h>

struct Entry
{
    Entry() : req(0), sent(0), user(0),
                addressLocalPort(0),
                addressRemotePort(0),
                mark(false), count(0),
                incoming(true), incomingString("<"),
                incomingPort(0), enabled(true)
    {
        id = Entry::globalid++;
    }

    QString protocol,
            addressLocal,
            addressRemote,
            state,
            inode,
            service,
            app;

    int req, sent, user,
        addressLocalPort,
        addressRemotePort;

    bool mark;
    int count;
    bool incoming;
    QString incomingString;
    int incomingPort;
    QString userString;
    bool enabled; // for ignore lists support

    static unsigned long globalid;
    unsigned long id;

    QDateTime time;

    QString tableEntry() const;
};

inline
bool operator== (const Entry &a, const Entry &b)
{
    return
        a.service           == b.service       &&
        a.protocol          == b.protocol      &&
        a.user              == b.user          &&
        a.addressRemote     == b.addressRemote &&
        a.addressRemotePort == b.addressRemotePort &&
        a.addressLocalPort  == b.addressLocalPort  &&
        a.app               == b.app;
}

#endif
