/***************************************************************************
                          kconnections.h  -  description
                             -------------------
    begin                : Втр Дек  4 20:35:42 UTC 2007
    copyright            : (C) 2007 by Krasu
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KWHO_H
#define KWHO_H

#include <qtooltip.h>

#include <ksystemtray.h>

class QTimer;
class QStringList;

class KProcess;

class KWEntry;
class KWLabel;
class KWIgnore;
class KWConfig;
class KWMonitor;

struct Entry;

/*
 *  QToolTip interface is too highlevel. We cann't create custom tips
 *  and update them dynamically. KWDynamicTip is just a hack, ugly hack
 *  to let us change tip's content dynamically.
 */
class KWDynamicTip : public QToolTip
{
    public:
        KWDynamicTip(QWidget *parent);

        void setText(const QString &t);

    protected:
        void maybeTip( const QPoint &);

    private:
        QString text;
};

inline
void KWDynamicTip::setText(const QString &t)
{
    text = t;
}

class KConnections : public KSystemTray
{
    Q_OBJECT 

    public:
        KConnections(QWidget *parent = 0, const char *name = 0);
        ~KConnections();

        void updateGeometries();
        void listChanged();
        bool timeToo() const;

    protected:
        virtual void mousePressEvent(QMouseEvent *);

    private:
        void processList(const QStringList &);
        void rereadSettings();

    signals:
        void added(const Entry &);
        void deleted(const Entry &);

    private slots:
        void slotAdded(const Entry &);
        void startMon();
        void startMonHack();
        void slotReceivedStdout(KProcess *, char *, int);
        void slotExited();
        void slotOptions();
        void slotQuitRequest();
        void slotAcceptAll();
        void slotIgnoreAll();
        void slotBlack();
        void slotWhite();

    private:
        QTimer *timer;
        QString buffer;
        KWEntry *entry;
        KWLabel *label;
        int delay;
        bool inctime, messages, messages_con, messages_discon;
        KWDynamicTip *tip;
        KWIgnore *ign;
        KWConfig *kconf;
        KWMonitor *kwm;
        KProcess *proc;
};

inline
bool KConnections::timeToo() const
{
    return inctime;
}

#endif
