/***************************************************************************
                          kwiconlistitem.h  -  description
                             -------------------
    begin                : ??? Dec 05 2007
    copyright            : (C) 2007 by Baryshev Dmitry
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KWICONLISTITEM_H
#define KWICONLISTITEM_H

#include <qlistbox.h>

class QListBox;
class QPainter;
class QPixmap;

/*
 *  Stolen from KSquirrel
 */

/* 
 *  KWIconListItem represents a listbox item.
 *
 *  With KWIconListBox it is used in KWOptions.
 *
 *  Taken from kdelibs.
 */

class KWIconListItem : public QListBoxItem
{
    public:
        KWIconListItem(QListBox *listbox, const QPixmap &pixmap, const QString &text);

        virtual int height(const QListBox *lb) const;
        virtual int width(const QListBox *lb) const;
        int expandMinimumWidth(int width);

    protected:
        const QPixmap& defaultPixmap();
        void paint(QPainter *painter);

    private:
        QPixmap mPixmap;
        int mMinimumWidth;
};

#endif
