/***************************************************************************
                          kwignore.h  -  description
                             -------------------
    begin                : ??? Dec 6 2007
    copyright            : (C) 2007 by Krasu
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KWIGNORE_H
#define KWIGNORE_H

#include <qvaluevector.h>

#include "entry.h"

class KWIgnore
{
    public: 
	    KWIgnore();
    	~KWIgnore();

        enum Type { Accept, Reject, Black, White };

        void rereadType();
        void reread();

        /*
         *  Return true to ignore connection
         */
        bool search(const Entry &e);

        int ignoreType() const;

        static KWIgnore* instance() { return m_inst; }

    private:
        void rereadPrivate(QValueVector<Entry> *);

    private:
        static KWIgnore *m_inst;
        QValueVector<Entry> ignore, accept;
        Type ignType;
};

inline
int KWIgnore::ignoreType() const
{
    return (int)ignType;
}

#endif
